{$define i80x86}
{$ifndef MSDOS}
  {  ⫠ $define gmem}
{$endif}
unit BigArray;
{
쥪 tBigArray ᯥ稢 ਧ    ᨢ.
᫨ ࠧ ᨢ ॢ蠥 쥬 ⨢ 
  ⨢ ,     १ 㭪樨
GetMem  New BigArray ⤠ ᪮쪮 ᨫ.
 ஢  ⮫쪮   ணࠬ   䫨
 ﬨ 墠뢠騬 ࠡ稪 HeapError.
}

interface

{$I-,S-,Q-}
uses
{$ifdef Windows}
  Dos2Win,
{$else}
  Dos,
{$endif}
Objects;

const
  FirstRecno = 0;
  NoRecno = -1;
  vfContain = $2; {ন }
  vfModif = $1; { ஢ ᫥ ᯫ}
  vfAbsent = $4; {}

type
  tRecNo = LongInt;

  pBigArray = ^tBigArray;
  tBigArray = object(tObject)
  Range : tRecNo;
  Blocks : Word;
  ItemSize : Word;
  OptSels : pByteArray;
  FIFO : boolean;
  constructor Init(
  aFn : PathStr;{ 䠩 ᢮, ᫨ ''
                   ᯮ 㭨쭮 }
  SizeItem : Word;{  ᨢ}
  aMaxBlockSize : LongInt; {ᨬ ࠧ  ࠭ ਧ樨,
    ந⥫쭮 ந ࠧ}
  aOffset : LongInt);
  procedure SetRange(aRange : tRecno); {⠭ - ⮢  ᨢ}
  procedure Get(var Data; N : tRecNo);
  function Search(const Key; var Index: LongInt): Boolean;
  procedure Put(const Data; N : tRecNo);
  procedure Flush;
  procedure Append(const Data);
  procedure PutArray(const Data; fN,qN : LongInt);
  function AtR(N : tRecNo) : Pointer; {⥫  ⥭}
  function AtW(N : tRecNo) : Pointer; {⥫  䨪樨}
  {⥫ ४ ⮫쪮  ᫥饣 饭 
  ⮤ 㯠  ⠬ ᨢ}
  procedure QuickSort;
  procedure ChangeSwap; virtual;
  function Compare(const d1,d2) : integer; virtual;
  destructor Done; virtual;
  destructor Delete; virtual; {  㤠 䠩 ᢮}
  private
    BlockSize,
    MaxItemInBlock : Word; {    - 1}
    Shifts : byte;
    Sorted : boolean;
    Selectors : pWordArray;
    Stream : pDosStream;
    FileName : PathStr;
    Offset : LongInt;
    wrepl,rrepl:Longint;
  end;

procedure InitBigArray;
procedure DoneBigArray;

implementation

uses Hex,except7
{$ifdef gmem}
  {$ifdef Windows}  ,WinProcs  {$endif}
  {$ifdef DPMI}  ,WinAPI  {$endif}
{$else}
  {$ifdef Windows}  ,oMemory  {$endif}
  {$ifdef DPMI}  ,Memory  {$endif}
{$endif}
;

type

pBlockInMem = ^tBlockInMem;
tBlockInMem = record
  Block : Word;
  InArr : pBigArray;
  Next  : pBlockInMem;
end;

const
  MaxBlockSize = $10000-8;
  DefBlockSize =
{$ifdef MSDOS}
  $2000;
{$else}
  $4000;
{$endif}

const
  FirstOut : pBlockInMem = nil;

{$ifdef MSDOS}
function MemAllocSeg(Size: Word): Pointer;
var
  P, T: Pointer;
begin
  Size := (Size + 7) and $FFF8;
  GetMem(p,Size + 8);
  if PtrRec(P).Ofs = 0 then
  begin
    PtrRec(T).Ofs := Size and 15;
    PtrRec(T).Seg := PtrRec(P).Seg + Size shr 4;
  end else
  begin
    T := P;
    PtrRec(P).Ofs := 0;
    Inc(PtrRec(P).Seg);
  end;
  FreeMem(T, 8);
  MemAllocSeg := P;
end;
{$endif MSDOS}

function HeapFunc(Size: Word): Integer; far; forward;

procedure ReallocBlock(Block : Word;var aSelf : tBigArray);
var
  p : pointer;
  Reg : pBlockInMem;
  cn : Word;
begin
with aSelf do begin
{  writeln('up',rrepl);
  rrepl:=0;}
  repeat
{$ifndef gmem}
    p := MemAllocSeg(BlockSize);
{$else}
    p := GlobalLock(GlobalAlloc(HeapAllocFlags,BlockSize));
{$ifdef DEBUG}
  if word(p)<>0 then HaltWithMessage('GMEM ᯮ짮 ');
{$endif}
{$endif}
    if p = nil then begin
      if HeapFunc(BlockSize)=0 then RunError(203);
      continue;
    end else Break;
  until False;
  if (OptSels^[block] and vfContain)=0 then begin
    FillChar(p^,BlockSize,#0);
    SetBitByte(OptSels^[block],vfModif);
  end else begin
    Stream^.Seek(LongInt(Block)*BlockSize+Offset);
    if DosRead(p^,BlockSize,Stream^.Handle)=$FFFF then
       ErrorMessage('BigStreamReadError'+StrInt(Stream^.Status,0));
    ResetBitByte(OptSels^[block],vfModif);
  end;
  ResetBitByte(OptSels^[block],vfAbsent);
  Selectors^[block] := Seg(p^);
  New(Reg);
  if FirstOut<>nil then Reg^ := FirstOut^
  else FirstOut := Reg;
  FirstOut^.Block := Block;
  FirstOut^.InArr := @aSelf;
  FirstOut^.Next := Reg;
  if not FIFO then FirstOut := Reg;
{  ChangeSwap;}
end;
end;

{$ifdef gmem}
function GlobalFreeSeg(Segm : Word): word; assembler;
asm
	PUSH	Segm
	CALL	GlobalHandle
	PUSH	AX
	PUSH	AX
	CALL	GlobalUnlock
	CALL	GlobalFree
end;
{$endif gmem}


procedure DropBlock(Block : Word;var aSelf : tBigArray);
var
  cn : Word;
begin
with aSelf do begin
{  writeln('down',wrepl);
  wrepl:=0;}
  if (OptSels^[block] and vfModif)<>0 then begin
    Stream^.Seek(LongInt(Block)*BlockSize+Offset);
    Stream^.Write(Ptr(Selectors^[Block],0)^,BlockSize);
    if Stream^.Status<>stOk then begin
      ErrorMessage('BigStreamWriteError'+StrInt(Stream^.Status,0));
      stream^.Reset;
    end;
  end;
{$ifndef gmem}
  FreeMem(Ptr(Selectors^[Block],0),BlockSize);
{$else}
  if GlobalFreeSeg(Selectors^[Block])<>0 then
    HaltWithMessage('GmemBigFree');
{$endif}
  SetBitByte(OptSels^[block],vfAbsent);
  ChangeSwap;
end;
end;

constructor tBigArray.Init(
  aFn : PathStr;
  SizeItem : Word;
  aMaxBlockSize : LongInt;aOffset : Longint);
var
  cn : Word;
begin
  Inherited Init;
  FIFO := False;
  Range := 0;
  Blocks := 0;
  Offset := aOffset;
  if (aMaxBlockSize = 0) then aMaxBlockSize := DefBlockSize;
  if (aMaxBlockSize>MaxBlockSize) then aMaxBlockSize := MaxBlockSize;
  if (aMaxBlockSize < LongInt(SizeItem) shl 1) then
    aMaxBlockSize := (SizeItem shl 1 -1);
  ItemSize := SizeItem;
  Shifts := 0;
  while SizeItem < (aMaxBlockSize shr 1) do begin
    SizeItem := SizeItem shl 1;
    Inc(Shifts);
  end;
  BlockSize := SizeItem;
  MaxItemInBlock := (1 shl Shifts) - 1;
  if aFN = '' then aFN := tmpFileName;
  FileName := aFn;
  Stream := New(pDosStream,Init(w_(aFN),stOpen));
  if Stream^.Status<>stOk then begin
    Dispose(Stream,Done);
    Stream := New(pDosStream,Init(w_(aFN),stCreate));
  end else begin
    SetRange((Stream^.GetSize-Offset) div ItemSize);
    FillChar(OptSels^,Blocks*SizeOf(OptSels^[0]),vfAbsent+vfContain);
{tmp??????}Sorted := True;
  end;
end;

procedure tBigArray.ChangeSwap;
begin
end;

procedure tBigArray.SetRange(aRange : tRecno);
var
  Sels : pWordArray;
  Opts : pByteArray;
  aBlocks : Word;
  Bm : Word;
label re;
begin
  aBlocks := (aRange shr Shifts);
  if (aRange and MaxItemInBlock)<>0 then Inc(aBlocks);
  if aBlocks=Blocks then goto re;
  GetMem(Sels, aBlocks*SizeOf(Selectors^[0]));
  GetMem(Opts, aBlocks*SizeOf(OptSels^[0]));
  FillChar(Opts^,aBlocks*SizeOf(OptSels^[0]),vfAbsent);
  FillChar(Sels^,aBlocks*SizeOf(Selectors^[0]),#0);
  if Blocks<>0 then begin
    if Blocks <= aBlocks then Bm := Blocks else begin
      for Bm := aBlocks to Blocks-1 do ResetBitByte(OptSels^[bm],vfModif);
      Flush;
      Bm := aBlocks;
    end;
    Move(Selectors^,Sels^,Bm*SizeOf(Selectors^[0]));
    Move(OptSels^,Opts^,Bm*SizeOf(OptSels^[0]));
    FreeMem(Selectors, Blocks*SizeOf(Selectors^[0]));
    FreeMem(OptSels, Blocks*SizeOf(OptSels^[0]));
  end;
  Selectors := Sels;
  OptSels := Opts;
  Blocks := aBlocks;
re:
  Range := aRange;
end;

function tBigArray.AtR(N : tRecNo) : Pointer; { 쪮  ⥭ }
{$ifndef i80x86}
var
  Block : Word;
begin
  Block := N shr Shifts;
  if (OptSels^[block] and vfAbsent)<>0 then ReallocBlock(block,Self);
  AtR := Ptr(Selectors^[block], Word(N and MaxItemInBlock)*ItemSize);
{$ELSE}
assembler;
  asm
    mov ch,0
    les di,Self
    mov cl,tBigArray[es:di].Shifts
    mov ax,tBigArray[es:di].MaxItemInBlock
    mov bx,word(N)
    and ax,bx  { in AX offset in block }
    mul tBigArray[es:di].ItemSize

    mov dx,word(N+2)
    shr bx,cl    { in BX Block number}
    sub cl,16
    neg cl
    shl dx,cl
    or bx,dx

    lds si,tBigArray[es:di].OptSels
    test byte ptr [si+bx],vfAbsent

    jz @2
    push cx
    push ds
    push si
    push ax
    push bx
    push bx
    push es
    push di
    mov ax,seg @data
    mov ds,ax
    call ReallocBlock
    pop bx
    les di,Self
    pop ax
    pop si
    pop ds
    pop cx
@2:
    or byte ptr [si+bx],ch
    les di,tBigArray[es:di].Selectors
    shl bx,1
    mov dx,[es:di+bx]
    push seg @data
    pop ds
{$endif}
end;

function tBigArray.AtW(N : tRecNo) : Pointer;
{$ifndef i80x86}
var
  Block : Word;
  Opt : ^byte;
begin
  block := N shr Shifts;
  Opt := @OptSels^[block];
  if (Opt^ and vfAbsent)<>0 then ReallocBlock(block,Self);
  SetBitByte(Opt^,vfContain+vfModif);
  Atw := Ptr(Selectors^[block], Word(N and MaxItemInBlock)*ItemSize);
{$else} assembler;
  asm
    mov ch,vfContain+vfModif
@1: mov ax,offset AtR
    sub ax,offset AtW
{$ifdef MSDOS}
    mov bx,offset @1
    mov byte ptr [cs:bx],0EBh
    sub al,2
    mov byte ptr [cs:bx+1],al
    jmp @1
{$else}
    add ax,offset @1
    jmp ax
{$endif}
{$endif}
end;

procedure DisposeBlock(var MBlock:pBlockInMem);
var
  p : pBlockInMem;
begin
  DropBlock(MBlock^.Block, MBlock^.InArr^);
  if MBlock^.Next = MBlock then begin
    Dispose(MBlock); MBlock:=nil;
  end else begin
    p:=MBlock^.Next;
    MBlock^:=MBlock^.Next^;
    Dispose(P);
  end;
end;

procedure tBigArray.Flush;
var
  LookB : tBlockInMem;
begin
  while (FirstOut<>nil) and (FirstOut^.InArr=@Self) do
    DisposeBlock(FirstOut);
  if FirstOut<>nil then begin
    LookB := FirstOut^;
    repeat
      FirstOut := FirstOut^.Next;
      while FirstOut^.InArr=@Self do DisposeBlock(FirstOut);
    until (FirstOut^.Block=LookB.Block) and (FirstOut^.InArr=LookB.InArr);
  end;
end;

procedure Disp(NeedFlush : Boolean; var aSelf :tBigArray);
var
  cn : Word;
begin
with aSelf do begin
  if not NeedFlush then begin
    cn:=0;
    while cn<Blocks do begin
      ResetBitByte(OptSels^[cn],vfModif);
      inc(cn);
    end;
  end else begin
    Stream^.Seek(Range*ItemSize+Offset);
    Stream^.Truncate;
  end;
  Flush;
  FreeMem(Selectors, Blocks*SizeOf(Selectors^[0]));
  FreeMem(OptSels,   Blocks*SizeOf(OptSels^[0]));
  Dispose(Stream,done);
end;
end;

destructor tBigArray.Delete;
begin
  Disp(False,Self);
  DelFile(FileName);
  Inherited Done;
end;

destructor tBigArray.Done;
begin
  Disp(True,Self);
  Inherited Done;
end;

procedure tBigArray.Get(var Data; N : LongInt);
begin
  Move(AtR(N)^,Data,ItemSize);
end;

procedure tBigArray.Put(const Data; N : LongInt);
begin
  Move(Data,AtW(N)^,ItemSize);
end;

procedure tBigArray.Append(const Data);
begin
  SetRange(Range+1);
  sorted := False;
  Move(Data,AtW(Range-1)^,ItemSize);
end;

procedure tBigArray.PutArray(const Data; fN,qN : LongInt);
var
  cn : longint;
  p : pointer;
begin
  p := @data;
  for cn := fN to fN+qN-1 do begin
    Move(p^,AtW(cn)^,ItemSize);
    inc(Word(p),ItemSize);
  end;
end;

procedure tBigArray.QuickSort;
var
  x,y : pointer;
  ex : tExcept;

procedure Sort(l, r: LongInt);
var
  i, j : LongInt;
begin
  i := l; j := r; Get(X^,(l+r) DIV 2);
  repeat
    while Compare(x^,AtR(i)^)>0 do i := i + 1;
    while Compare(AtR(j)^,x^)>0 do j := j - 1;
    if i <= j then
    begin
      if i<>j then begin
        Get(Y^,i);
        Put(AtR(j)^,i);
        Put(Y^,j);
      end;
      i := i + 1; j := j - 1;
    end;
  until i > j;
  if l < j then Sort(l, j);
  if i < r then Sort(i, r);
end;

begin
  GetMem(X,ItemSize);
  GetMem(Y,ItemSize);
  rrepl :=0;
  wrepl := 0;
if Try7(ex) then begin
  if Range>1 then Sort(0,Range-1);
  endTry(ex);
end;
  FreeMem(X,ItemSize);
  FreeMem(Y,ItemSize);
  reThrow(ex);
  Sorted := True;
end;

function tBigArray.Compare(const d1,d2) : integer;
begin Abstract; end;

function tBigArray.Search(const Key; var Index: LongInt): Boolean;
var
  L, H, I : LongInt;
  C : shortint;
begin
  if not Sorted then QuickSort;
  Search := False;
  L := 0;
  H := Range - 1;
  while L <= H do
  begin
    I := (L + H) shr 1;
    C := Compare(AtR(I)^, Key);
    if C < 0 then L := I + 1 else
    begin
      H := I - 1;
      if C = 0 then Search := True;
    end;
  end;
  Index := L;
end;

type
  theapFunction = function(Size : Word) : integer;

var
  oldHeap :  pointer;

function HeapFunc(Size: Word): Integer;
var
  Res : integer;
begin
  if (FirstOut=nil) or (Size=0) then begin
    if oldHeap<>nil then HeapFunc := tHeapFunction(oldHeap)(Size)
    else HeapFunc := 0;
    Exit;
  end;
  DisposeBlock(FirstOut);
  HeapFunc := 2;
end;

procedure InitBigArray;
begin
  InitExceptions;
  if HeapError<>@HeapFunc then begin
    oldHeap := HeapError;
    HeapError := @HeapFunc;
  end;
end;

procedure DoneBigArray;
begin
  if HeapError<>@HeapFunc then ErrorMessage(OemStr('墠祭 HeapError'));
  if FirstOut<>nil then
     ErrorMessage(OemStr('  ࠭ 襭'));
  HeapError := oldHeap;
end;

end.