unit Dos2Win;

interface

{$IFDEF Windows}
uses WinDos;
type

  tPathStr = array [0..79] of char;
  tNameStr = array [0..8] of char;
  tExtStr = array [0..4] of char;
  tDirStr = array [0..67] of char;

  PathStr = String[79];
  NameStr = String[8];
  ExtStr = String[4];
  DirStr = String[67];
  SearchRec = record
    Fill : array[1..21] of Byte;
    Attr : Byte;
    Time : Longint;
    Size : Longint;
    Name : string[12];
  end;
  DateTime = tDateTime;

const
  Archive = faArchive;
  ReadOnly = faReadOnly;
  Hidden   = faHidden;
  SysFile  = faSysFile;
  VolumeID = faVolumeID;
  Directory = faDirectory;
  AnyFile  = faAnyFile;
var
  DosError : integer Absolute WinDos.DosError;

procedure FSplit(Path: PathStr; var Dir: DirStr; var Name: NameStr;
var Ext: ExtStr);
procedure FindFirst(const Path:PathStr;Attr: Word; var F: SearchRec);
procedure FindNext(var F: SearchRec);
function FExpand (Path: PathStr): PathStr;
function GetEnv(EnvVar: string): string;

implementation

uses Strings,Hex;

function GetEnv(EnvVar: string): string;
var
  Env : pChar;
begin
  Env := GetEnvVar(pChar_(EnvVar));
  if env <> nil then GetEnv := StrPas(Env)
  else GetEnv := '';
end;

procedure FSplit(Path: PathStr; var Dir: DirStr; var Name: NameStr;
var Ext: ExtStr);
var
Path_: tPathStr;
Dir_: tDirStr;
Name_: tNameStr;
Ext_: tExtStr;
begin
  StrPCopy(Path_,Path);
  FileSplit(Path_,Dir_,Name_,Ext_);
  Dir := StrPas(Dir_);
  Name := StrPas(Name_);
  Ext := StrPas(Ext_);
end;

procedure FindFirst(const Path: PathStr; Attr: Word; var F: SearchRec);
var
  Path_ : tPathStr;
  Sr : tSearchRec Absolute F;
begin
  StrPCopy(Path_,Path);
  WinDos.FindFirst(Path_,Attr,Sr);
  F.Name := StrPas(Sr.Name);
end;

procedure FindNext(var F: SearchRec);
var
  Sr : tSearchRec Absolute F;
begin
  StrPCopy(Sr.Name,F.Name);
  WinDos.FindNext(Sr);
  F.Name := StrPas(Sr.Name);
end;

function FExpand (Path: PathStr): PathStr;
var
  Path_ : tPathStr;
begin
  StrPCopy(Path_,Path);
  FExpand := StrPas(FileExpand(Path_,Path_));
end;

{$ELSE}
implementation
{$ENDIF}

end.
