unit Except7;

interface

const
  NotException    = 0;
  exDivisionBy0   = 1;
  exStackOverflow = 2;
  exLowMemory     = 3;
  exFileNotFound  = 4;
  exMessage       = 5;
  exCantCreateFile= 6;
  exCantOpenFile  = 7;
  exCancel        = 8;
  exAbstract      = 9;
  exAbort         = 10;
  exRunError      = 11;
  exCmdLine       = 12;
  exLast          = 13;

type

  pExcept = ^tExcept;
  tExcept = object
  id : integer;
  p : pointer;
  rSS,rSP,rBP,rCS,rIP : Word;
  Next : pExcept;
  constructor init;
  end;

 tDevEx = object(tExcept) end;

procedure InitExceptions;
function Try7(var ex : tExcept):boolean;
procedure EndTry(const ex : tExcept);
procedure Throw(id : integer;p : pointer);
procedure ReThrow(const ex : tExcept);


implementation

uses Hex;

const
  rIP = 2;
  rCS = 4;
  Here : pExcept=nil;

function Try7(var ex : tExcept): boolean;assembler;
asm
  les di,ex
  mov tExcept(es:[di]).id,NotException
  mov tExcept(es:[di]).rSS,SS
  mov tExcept(es:[di]).rSP,BP
  mov ax,[bp]
  mov tExcept(es:[di]).rBP,AX
  mov ax,[BP+rCS]
  mov tExcept(es:[di]).rCS,AX
  mov ax,[BP+rIP]
  mov tExcept(es:[di]).rIP,AX
  mov ax,Word ptr Here+2
  mov Word ptr (tExcept(es:[di]).Next)+2,ax
  mov ax,Word ptr Here
  mov Word ptr (tExcept(es:[di]).Next),ax
  mov Word ptr Here+2,es
  mov Word ptr Here,di
  mov ax,1
end;

procedure ReThrow(const ex : tExcept);
begin
  if (ex.id<>NotException) then throw(ex.id,ex.p);
end;

procedure Throw(id : integer;p : pointer);assembler;
asm
  les di,Here
  mov ax,id
  mov tExcept(es:[di]).id,ax

  mov ax,Word(p+2)
  mov Word(tExcept(es:[di]).p+2),ax

  mov ax,Word(p)
  mov Word(tExcept(es:[di]).p),ax

  mov SS,tExcept(es:[di]).rSS
  mov BP,tExcept(es:[di]).rSP

  mov ax,tExcept(es:[di]).rBP
  mov [bp],ax

  mov Ax,tExcept(es:[di]).rCS
  mov [BP+rCS],ax

  mov ax,tExcept(es:[di]).rIP
  mov [BP+rIP],ax

  mov ax,Word ptr (tExcept(es:[di]).Next)+2
  mov Word ptr Here+2,ax

  mov ax,Word ptr (tExcept(es:[di]).Next)
  mov Word ptr Here,ax

  xor ax,ax
  leave
  retf 4
end;

procedure EndTry(const ex : tExcept);
begin
  if Here<>@ex then ErrorMessage('Try without EndTry');
  Here := Here^.Next;
end;

var
  oldHeap : pointer;
  oldExit : pointer;

function HeapFunc(Size: Word): Integer; far;
var
  res : Word;
type
  theapFunction = function(Size : Word) : integer;
begin
  Res := 0;
  if oldHeap<>nil then Res := tHeapFunction(oldHeap)(Size);
  if (Size<>0) and (Res=0) then
    throw(exLowMemory,ptr(0,Size))
  else HeapFunc := Res;
end;

procedure ExitEx; far;
begin
  if ErrorAddr<>nil then begin
    ErrorAddr := nil;
{$ifndef MSDOS}
    if (ExitCode=216) then begin
      ErrorMessage('਩ 室  ᫥⢨  ४⭮ 樨.');
    end else
{$endif}
    throw(exRunError,Ptr(0,ExitCode));
  end;
  if HeapError = @HeapFunc then HeapError := oldHeap;
  ExitProc := oldExit;
  if (ExitCode=0) and (ErrorAddr=nil) and (Here<>nil) then
    ErrorMessage('訡 ᫥ try endtry');
end;

constructor tExcept.init;
begin
end;

procedure InitExceptions;
var
  ex : tExcept;
  exd : tDevEx;
  p : pointer;
  w : word;
begin
  if HeapError <> @HeapFunc then begin
    oldHeap := HeapError;
    HeapError := @HeapFunc;
  end;
  if ExitProc<>@ExitEx then begin
    oldExit := exitProc;
    ExitProc := @ExitEx;
  end;
end;

end.
