unit hex;

interface

uses
{$ifdef Windows}
WinProcs,WinTypes,
WinDos,
Dos2Win,
{$ifdef ver80}
messages,
{$endif}
{$endif}
{$ifdef DPMI}
WinAPI,
{$endif}
{$ifndef Windows}
{$ifndef Win32}
Dos,
{$else}
WinDos,
{$endif}
{$ENDIF}
except7
;

var
  BiosTime : ^LongInt;

const
  TicksInMin = 1092;
  ExitWithMessage = 4;

  exStr2Long = except7.exLast;
  exStr2Date = except7.exLast+1;
  exLast = except7.ExLast+2;

  StrMonth : Array [1..12] of String[8] =
  (
  'ﭢ',
  '䥢ࠫ',
  '',
  '५',
  '',
  '',
  '',
  '',
  'ᥭ',
  '',
  '',
  '');


type
  NameExtStr = String[12];
{$ifdef ver70}
  smallint = integer;
{$endif}

tStrInt = string[10];

function DosRead(var Buf; Count: Word; Handle : Word) : Word;
function FHDup(h : integer) : integer;
function FreeHandles : Word;

function WithExt(aExt : ExtStr) : PathStr;
function WithName(aName : NameExtStr) : PathStr;
function ChangeExt(const aPath : String; aExt : ExtStr) : PathStr;
function DirOfFileName(Fn : PathStr) : DirStr;
function GetNameExt(const Fn : PathStr) : NameExtStr;
function ParamNext(Cnt : integer) : String;

function MaxLong(l1,l2 : longint) : longint;
function CompareStrings(const Key1,Key2 : String) : integer;
function AllTrim(const Sv : OpenString) : String;
procedure fillStr(var S : OpenString; V : Char);
function Posit(var S; c : byte; Numb : Word) : Word;
procedure SetBitByte(var It:byte; Mask : byte);
procedure ResetBitByte(var It:byte; Mask : byte);
procedure SetBitWord(var It : Word; Mask : Word);
procedure ResetBitWord(var It : Word; Mask : Word);
function TmpFileName : PathStr;
procedure DelFile(const It : PathStr);
procedure DelFiles(It : PathStr;Attr : Word);
procedure RewriteFile(const S,D : PathStr);
function RenameFile(const S,D : PathStr) : Boolean;
function FileExists(aF : PathStr) : Boolean;
function Str2Long(const S : String) : LongInt;
function Chars2Long(ch : pChar) : LongInt;
function Long2Str(S : LongInt; width : Word) : tStrInt;
function Long_2Str(S : LongInt; width : Word) : tStrInt;
function left(St : String;N : byte) : String;
function SymPoints : integer;
procedure LoadSymbols(sym : char; ps : integer; const bin : String);

function WordComp(w1,w2 : Word) : integer;
function MemComp(const Rec1, Rec2; MaxLen: Word): Integer;
function CompIncStr(const s1 : String;const s2 : String) : integer;
function MemPos(Str1 : Pointer;Str2 : pChar; Size1: Word) : pointer;
function UpStr(const Str : String) : String;

function Percents(Part,It:LongInt) : String;

function StrHex(const S; size : Word) : String;
function StrLongHex(d : LongInt) : String;
procedure ValH(const Sv : String ; var D; size : Word);
procedure WrHex(const V; Size : Word);
function LongValue(var S : String) : Longint;
function StrInt(S : LongInt; width : Word) : tStrInt;

procedure WriteBIOS(const S : String);
procedure SetCursor(row,col : byte);

procedure DisableInt; inline($FA); {CLI}
procedure EnableInt; inline($FB);  {STI}
function CMOSByte(adr : byte) : byte;
procedure HaltWithMessage(const Msg : String);
function ULongComp(ul1,ul2 : longint) : integer;

procedure unexpected(const ex : tExcept);
procedure unhandled(const ex : tExcept);
function PushKey(KeyCode : Word) : Boolean;
function ReadKeyCode : Word; inline($31/$C0/$CD/$16);
function LookKeyCode : Word;
procedure ClearKeyboardBuffer;
procedure ind;

procedure CopyFTime(hs,hd : Word);
function pChar_(const Str : String) : pChar; far;
{$ifdef Windows}
type
  FnpChar = function(const Str : String):pChar;
const
  w_ : FnpChar = pChar_;
{$else}
function w_(const Path : PathStr) : PathStr;
{$endif}
function OemStr(const str : string) : String;
function AnsiStr(const str : string) : String;
function Ansi2Alter(const S : String) : String;
function Real2Protected(Rp : pointer; Size : Word) : pointer;

type
  tOutCode = (mbOk,mbCancel,mbAbort,mbRetry,mbIgnore,mbYes,mbNo);
  tInCode = set of tOutCode;
  tRecod = array [tOutcode] of integer;

  tStdioGauge = object
    MaxValue : LongInt;
    CurValue : LongInt;
    MaxLen : byte;
    CurLen : byte;
    procedure Reset(MaxVal : LongInt; LenStr : byte);
    procedure Update(Progress: Longint);
    procedure AddProgress(Progress: Longint);
    procedure Clear;
private
    procedure WrStr(chr : char);
  end;


{$ifndef MSDOS}
tRealMem = object
Realptr,ProtPtr : pointer;
constructor copy(it : pointer;Size : Word);
constructor init(Size : Word);
destructor Done;
end;

function GetRealInt(i : byte) : pointer;
{$endif}

var
  ErrorMessage : procedure(const msg : String);
{  SayMessage : function(const msg : String;IC : tInCode):tOutCode;
  EditString : function(const msg : String;var str:String;IC:tInCode):tOutCode;}
  Idle : procedure;

implementation

uses lexems
,Strings
{$ifndef MSDOS}
,dpmi
{$ENDIF}
{$ifdef Windows}
{$ifndef VER80}
,Win31
{$else}

{$endif}
{$endif}
;

{----------------------------------------------------------------}
{ hhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhh }
{----------------------------------------------------------------}
function MaxLong(l1,l2 : longint) : longint;
begin
  if l1>l2 then MaxLong := l1
  else MaxLong := l2;
end;

procedure tStdioGauge.WrStr(chr : char);
var
  cn : byte;
begin
  write(#13);
  for cn := 0 to MaxLen-1 do write(chr);
  write(#13);
end;

procedure tStdioGauge.Clear;
begin
  wrstr(' ');
end;

procedure tStdioGauge.Reset(MaxVal : LongInt; LenStr : byte);
begin
  MaxLen := LenStr;
  MaxValue := MaxVal;
  CurValue := 0;
  CurLen := 0;
  wrstr('.');
end;

procedure tStdioGauge.Update(Progress: Longint);
var
  NewLen : byte;
  dv : integer;
  chr : String[3];
begin
  CurValue := Progress;
  NewLen := Progress * MaxLen div MaxValue;
  dv := integer(NewLen)-integer(CurLen);
  CurLen := NewLen;
  if dv>0 then chr := 'O'
  else begin
    chr := #8'.'#8;
    dv := -dv;
  end;
  while dv>0 do begin
    write(chr);
    dec(dv);
  end;
end;

procedure tStdioGauge.AddProgress(Progress: Longint);
begin
  Update(CurValue+Progress);
end;


function Real2Protected(Rp : pointer; Size : Word) : pointer;
var
  Sel : Word;
  lp : record Lo,Hi : Word; end Absolute rp;
begin
{$ifndef MSDOS}
  Sel := AllocSelector(0);
  if sel<>SetSelectorBase(Sel,(LongInt(lp.Hi) shl 4)+lp.Lo) then HaltWithMessage('Sel not alloc');
  SetSelectorLimit(Sel,Size);
  Real2Protected := Ptr(Sel,0);
{$else}
  Real2Protected := rp;
{$endif}
end;

function SymPoints : integer;
var
{$ifdef MSDOS}
rc : Registers;
{$else}
rc : tRealCall;
{$endif}
begin
  fillchar(rc,Sizeof(rc),#0);
  rc.ax := $1130;
  rc.bh := 3;
{$ifdef MSDOS}
intr($10,rc);
{$else}
Realintr($10,rc);
{$endif}
  SymPoints := rc.CX;
end;

procedure LoadSymbols(sym : char; ps : integer; const bin : String);
{$ifdef MSDOS}
var
  rg : Registers;
begin
  rg.AX := $1100;
  rg.BX := Swap(ps);
  rg.CX := length(bin) div ps;
  rg.DX := byte(sym);
  rg.ES := Seg(bin);
  rg.BP := Ofs(bin)+1;
  Intr($10,rg);
end;
{$else}
var
 rm : tRealMem;
 rc : tRealCall;
type longrec = record lo,hi : word; end;
begin
  fillchar(rc,Sizeof(rc),#0);
  Rm.Copy(@bin[1],length(bin));
  rc.rEAX := $1100;
  rc.rEBX := Swap(ps);
  rc.rECX := length(bin) div ps;
  rc.rEDX := byte(sym);
  rc.rES := LongRec(rm.RealPtr).Hi;
  rc.rEBP := LongRec(rm.RealPtr).Lo;
  RealIntr($10,rc);
  Rm.Done;
end;
{$endif}

function ParamNext(Cnt : integer) : String;
var
  Res : String;
begin
  Res := '';
  while true do begin
    insert(ParamStr(cnt),Res,Length(res)+1);
    inc(cnt);
    if cnt<=ParamCount then insert(' ',Res,Length(res)+1)
    else break;
  end;
  ParamNext := Res;
end;

function ULongComp(ul1,ul2 : longint) : integer; assembler;
asm
  cmp test8086,2
  JB @2
  db 66H; mov ax,word(ul1)
  db 66H; cmp ax,word(ul2)
  jae @1
  mov ax,-1
  jmp @4
@1:
  je @3
  mov ax,1; jmp @4;
@3:
  xor ax,ax;jmp @4
@2:

  mov ax,word(ul1)
  cmp ax,word(ul2)
  jae @11
  mov ax,-1
  jmp @4
@11:
  je @13
  mov ax,1; jmp @4;
@13:

  mov ax,word(ul1+2)
  cmp ax,word(ul2+2)
  jae @21
  mov ax,-1
  jmp @4
@21:
  je @23
  mov ax,1; jmp @4;
@23:
  xor ax,ax
@4:
end;

function WordComp(w1,w2 : Word) : integer; assembler;
asm
  mov bx,w1
  mov dx,w2
  cmp bx,dx
  jbe @1
  mov ax,1
  jmp @4
@1:
  jae @2
  mov ax,-1
  jmp @4
@2:
  xor ax,ax
@4:
end;

function DosRead(var Buf; Count: Word; Handle : Word) : Word; assembler;
asm
        PUSH    DS
        LDS     DX,Buf
        MOV     CX,Count
        MOV     BX,Handle
        MOV     AH,3FH
        INT     21H
        JNC     @1
        MOV CX, 0FFFFh
@1:     MOV     AX,CX
        POP     DS
end;



{$ifndef MSDOS}
constructor tRealMem.init(Size : Word);
var
  pl : record case byte of
    0 : (all : LongInt);
    1 : (l,h : Word);
  end;
begin
  pl.All := GlobalDosAlloc(Size);
  if pl.All=0 then throw(exLowMemory,nil);
  RealPtr := ptr(pl.h,0);
  ProtPtr := ptr(pl.l,0);
end;

constructor tRealMem.copy(it : pointer;Size : Word);
begin
  init(size);
  move(it^,ProtPtr^,Size);
end;

destructor tRealMem.Done;
begin
  GlobalDosFree(Seg(ProtPtr^));
end;

function GetRealInt(i : byte) : pointer; assembler;
asm
  mov bl,i
  mov ax,200h
  int 31h
  mov ax,dx
  mov dx,cx
end;

{$endif}


function FHDup(h : integer) : integer; assembler;
asm
  mov ah,45h
  mov bx,h
  int 21h
  jnc @4
  neg ax
@4:
end;

procedure FHClose(h : integer); assembler;
asm
  mov ah,3eh
  mov bx,H
  int 21h
end;

function FreeHandles : Word;
var
  cnt : Word;
procedure R;
var
  h : integer;
begin
  h := FHDup(1);
  if H<0 then Exit;
  inc(cnt);
  R;
  FHClose(h);
end;
begin
  cnt := 0;
  R;
  FreeHandles := cnt;
end;

procedure unhandled(const ex : tExcept);
begin
    if ex.id = exRunError then
      HaltWithMessage('Run error '+StrInt(Word(ex.p),0))
    else
    HaltWithMessage(' ࠡ⠭ ᪫祭 '+StrInt(ex.id,0));
end;

procedure unexpected(const ex : tExcept);
begin
  if ex.id=exRunError then
    HaltWithMessage('訡 No '+StrInt(Word(ex.p),0))
  else
  HaltWithMessage(' ᪫祭 '+StrInt(ex.id,0));
end;

procedure ind;
var
  x,y : integer;
const
  ia : array [0..3] of char = '/-\|';
  i : byte = 0;
label q;
begin
  asm
    INC I
    test i,1Fh
    jnz q
  end;
  write(ia[(i shr 5) and 3],#8);
  asm
q:
  end;
end;

function Str2Long(const S : String) : LongInt;
var
  cd : integer;
  Res : LongInt;
begin
  Val(S,Res,cd);
  if cd<>0 then Throw(exStr2Long,@S);
  Str2Long := Res;
end;

function Chars2Long(ch : pChar) : LongInt;
var
  cd : integer;
  REs : LongInt;
  str : string[15];
begin
  Val(ch,Res,cd);
  if cd<>0 then begin
    str := StrPas(ch);
    Throw(exStr2Long,@str);
  end;
  Chars2Long := Res;
end;

function RealFileName(fn : PathStr) : Boolean;
begin
  RealFileName := False;
  while not FileExists(fn) do begin
    Exit;
{    if EditString(
    ' '+fn+'  ,  㣮 '
    ,fn,[mbYes,mbNo])=mbCancel then Break;}
  end;
  RealFileName := True;
end;

function Percents(Part,It:LongInt) : String;
var
  Res : String;
  md : Real;
  ex : tExcept;
const
  bpr : array[boolean] of byte = (1,2);
begin
  if try7(ex) then begin
  md := Part/it*100;
  if Part<>0 then case Round(md) of
    10..$7FFF : Str(md:0:0,Res);
    1..9      : Str(md:0:1,Res);
    0         : Str(md:0:-Round(int(ln(md)/ln(10)))+1,Res);
  end
  else Res := '0';
  endTry(ex);
  end;
  Percents := Res +'%';
end;
{begin
  Part := (Part*10000 div It);
  Percents := StrInt(Part div 100,0)+'.'+StrInt(Part mod 100,2)+'%';
end;}

function MemComp(const Rec1, Rec2; MaxLen: Word): Integer; assembler;
asm
	PUSH	DS
	CLD
	MOV	CX,MaxLen
	LES	DI,Rec2
	LDS	SI,Rec1
	REPE	CMPSB
	MOV	AL,DS:[SI-1]
	MOV	DL,ES:[DI-1]
	SUB	AL,DL
        CBW
@@1:	POP	DS
end;

function CompIncStr(const s1 : String;const s2 : String) : integer;
begin
  CompIncStr := memcomp(s1[1],s2[1],-MaxLong(-length(s1),-length(s2)));
end;

function MemPos(Str1 : Pointer;Str2 : pChar; Size1:Word ) : pointer; assembler;
asm
	PUSH	DS
	CLD
	XOR	AL,AL
	LES	DI,Str2
	MOV	CX,0FFFFH
	REPNE	SCASB
	NOT	CX
	DEC	CX
	JE	@@2
	MOV	DX,CX

        mov cx, Size1
        inc cx
	SUB	CX,DX
	JBE	@@2

        les di,Str1
        mov ds,Str2.Word[2]

@@1:	MOV	SI,Str2.Word[0]
	LODSB
	REPNE	SCASB
	JNE	@@2
	MOV	AX,CX
	MOV	BX,DI
	MOV	CX,DX
	DEC	CX
	REPE	CMPSB
	MOV	CX,AX
	MOV	DI,BX
	JNE	@@1
	MOV	AX,DI
	MOV	DX,ES
	DEC	AX
	JMP	@@3
@@2:	XOR	AX,AX
	MOV	DX,AX
@@3:	POP	DS
end;

procedure WriteBIOS(const S : String); assembler;
asm
  push ds
  lds si,S
  mov cl,byte ptr [si]
  inc si
  xor ch,ch
  mov bl,15
  mov ah,0Eh
@1:
  lodsb
  int 10h
  loop @1
  pop ds
end;

procedure SetCursor(row,col : byte); assembler;
asm
  mov ah,2
  mov bh,0
  mov dh,row
  mov dl,col
  int 10h
end;

function UpStr(const Str: String): String;
var
  I: Integer;
begin
  UpStr[0] := Str[0];
  for I := 1 to Length(Str) do UpStr[I] := UpCase(Str[I]);
end;

function pChar_(const Str : String) : pChar;
const
  Res : array[0..255] of char = '';
begin
  pChar_ := StrPCopy(Res,Str);
end;

{$IFNDEF WINDOWS}
function w_(const Path : PathStr) : PathStr;
begin
 w_ := path;
end;
{$endif}

function OemStr(const Str : String) : String;
{$ifdef Windows}
var
  Sc,Dc : array [0..255] of char;
begin
  OemToAnsi(StrPCopy(Sc,Str),Dc);
  OemStr := StrPas(Dc);
{$else}
begin
  OemStr := Str;
{$endif}
end;

function Ansi2Alter(const S : String) : String;
var
  ch : char;
  cn : byte;
begin
  Ansi2Alter[0] := s[0];
  for cn := 1 to length(s) do begin
    ch := s[cn];
    case ch of
      ''..'' : Ansi2Alter[cn] := char(byte(ch) - byte('')+ byte(''));
      ''..'' : Ansi2Alter[cn] := char(byte(ch) - byte('')+ byte(''));
      else Ansi2Alter[cn] :=ch;
    end;
  end;
end;

function AnsiStr(const Str : String) : String;
{$ifndef Windows}
var
  chr : char;
  cn : byte;
begin
  AnsiStr[0] := Str[0];
  for cn := 1 to length(Str) do begin
     chr := Str[cn];
     if chr in [''..''] then dec(byte(chr),byte('')-128) else
     if chr in [''..''] then dec(byte(chr),byte('')-160) else
     if chr in [''..''] then dec(byte(chr),byte('')-224);
     AnsiStr[cn] := chr;
  end;
{$else}
begin
  AnsiStr := Str;
{$endif}
end;

function CMOSByte(adr : byte) : byte; assembler;
asm
  mov     al,adr
  out     70H,al
  jmp     @1
@1:
  in      al,71H
end;

function LongValue(var S : String) : Longint;
var
  Res : LongInt;
  code : Word;
begin
  Val(S,Res,code);
  LongValue := Res;
end;

function WithExt(aExt : ExtStr) : PathStr;
begin
  WithExt := ChangeExt(ParamStr(0),aExt);
end;

procedure DelFile(const It : PathStr);
var
  F : file;
begin
  Assign(f,It);
  {$I-}
  Erase(f);
  {$I+}
end;

function RenameFile(const S,D : PathStr) : Boolean;
var
  f : file;
begin
  Assign(f,S);
{$i-}
  Rename(f,D);
{$i+}
  RenameFile := IOResult=0;
end;

procedure RewriteFile(const S,D : PathStr);
begin
  DelFile(D);
  RenameFile(S,D);
end;

procedure SetBitWord(var It : Word; Mask : Word); assembler;
asm
  les di,It
  mov ax,Mask
  or ES:[DI],ax
end;

procedure ResetBitWord(var It : Word; Mask : Word); assembler;
asm
  les di,It
  mov ax,Mask;
  not ax
  and es:[di],ax
end;

procedure SetBitByte(var It : byte; Mask : byte); assembler;
asm
  les di,It
  mov al,Mask
  or ES:[DI],al
end;

procedure ResetBitByte(var It : byte; Mask : byte); assembler;
asm
  les di,It
  mov al,Mask;
  not al
  and es:[di],al
end;

function Posit(var S; c : byte; Numb : Word) : Word; assembler;
asm
  les di,S
  mov al,c
  mov cx,Numb
  repnz scasb
  jz @Yes
  mov cx,Numb
@Yes:
  sub cx,Numb
  neg cx
  mov ax,cx
end;

procedure fillStr(var S : OpenString; V : Char);
var
  rn : byte;
begin
  for rn := length(S)+1 to High(S) do S[rn] := V;
  S[0] := char(High(S));
end;

function CompareStrings(const Key1,Key2 : String) : integer; assembler;
asm
        PUSH    DS
        CLD
        LDS     SI,Key1
        LES     DI,Key2
        LODSB
        MOV     AH,ES:[DI]
        INC     DI
        MOV     CL,AL
        CMP     CL,AH
        JBE     @1
        MOV     CL,AH
@1:     XOR     CH,CH
        REP     CMPSB
        JE      @2
        MOV     AL,DS:[SI-1]
        MOV     AH,ES:[DI-1]
@2:     SUB     AL,AH
        SBB     AH,AH
        POP     DS
end;

function left(St : String;N : byte) : String;
begin
  while N > length(St) do insert(' ',St,length(St)+1);
  left := St;
end;

function AllTrim(const Sv: OpenString) : String;
var
  I: Integer;
  S : String;
begin
  I := 1;  S := String(Sv);
  while (I < Length(S)) and (S[I] = ' ') do Inc(I);
  if Length(S) <> 0 then
  begin
    Dec(S[0],I-1);
    Move(S[I],S[1],Length(S));
  end;
  while S[Length(S)] = ' ' do Dec(S[0]);
  AllTrim := S;
end;

procedure WrHex(const V; Size : Word);
begin
   Write(StrHex(V,Size));
end;

function StrLongHex(d : LongInt) : String;
begin
  StrLongHex := StrHex(d,4);
end;

function StrHex(const S; size : Word) : String; assembler;
{const
  trans : array [0..15] of char = '0123456789ABCDEF';}
asm
    push ds
    mov cx,size
    les di,@RESULT
    cld
    mov al,cl
    shl al,1
    stosb
    lds si,S
    add si,cx
    dec si
@1: std
    lodsb
    mov ah,al
    and ah,0Fh
    and al,0F0h
    shr al,1
    shr al,1
    shr al,1
    shr al,1
    add ax,'00'
    cmp al,'9'+1
    jc @2
    add al,'A'-'9'-1
@2: cmp ah,'9'+1
    jc @3
    add ah,'A'-'9'-1
@3: cld
    stosw
    loop @1
    pop ds
end;

procedure ValH(const Sv : String ; var D; size : Word);
var
  szs : Word;
  S : String;
begin
  S := AllTrim(Sv);
  szs := size shl 1;
  if (length(S) > szs) then S[0] := char(szs);
  Move(S[1],S[szs - length(s)+1],length(s));
  FillChar(S[1],szs - length(s),'0');
  S[0] := char(szs);
  asm
    push ds
    mov cx,size
    les di,d  {  ᫥ ࠧ ᫠ }
    add di,cx
    dec di
    lea si,s   {   ᨬ }
    push ss
    pop ds
    inc si
@1: cld
    lodsw
    cmp ah,'9'+1
    jc @2h
    and ah,not ('A' xor 'a')
    sub ah,'A'-'9'-1
@2h: cmp al,'9'+1
    jc @2l
    and al,not ('A' xor 'a')
    sub al,'A'-'9'-1
@2l: sub ax,'00'
    shl al,1
    shl al,1
    shl al,1
    shl al,1
    add al,ah
    std
    stosb
    loop @1
    pop ds
  end;
end;

function StrInt(S : LongInt; width : Word) : tStrInt;
var
  St : tStrInt;
  cn : Word;
begin
  Str(S : width,St);
  cn := 1;
  while (St[cn] = ' ') and (cn <= width) do begin
    St[cn] := '0';
    inc(cn);
  end;
  StrInt := St;
end;

function Long2Str(S : LongInt; width : Word) : tStrInt;
var
  St : tStrInt;
begin
  Str(S : width,St);
  Long2Str := St;
end;

function Long_2Str(S : LongInt; width : Word) : tStrInt;
var
  St : tStrInt;
begin
  Str(S : width,St);
  if S=0 then St[length(St)] := ' ';
  Long_2Str := St;
end;

procedure HaltWithMessage(const Msg : String);
begin
  ErrorMessage(Msg);
  Halt(ExitWithMessage);
end;

function LookKeyCode : Word; assembler;
asm
  mov ah,1
  int 16h
  jnz @4
  xor ax,ax
@4:
end;

function PushKey(KeyCode : Word) : Boolean; assembler;
asm
  mov ah,5
  mov cx,KeyCode
  int 16h
  xor al,1
end;
{
asm
   push ds
   mov ds,Seg0040
   mov bx,Word Ptr [1Ch]
   mov ax,KeyCode
   mov [bx],ax
   inc bx
   inc bx
   cmp bx,[82h]
   jnz @Ok
   mov bx,[80h]
@Ok:
   mov [1Ch],bx
   pop ds
end;
}

function WithName(aName : NameExtStr) : PathStr;
begin
  WithName := DirOfFileName(ParamStr(0))+aName;
end;

function ChangeExt(const aPath : String; aExt : ExtStr) : PathStr;
var
  Direct : DirStr;
  Name : NameStr;
  Ext  : ExtStr;
begin
  FSplit(aPath,Direct,Name,Ext);
  ChangeExt := Direct+Name+aExt;
end;

function DirOfFileName(Fn : PathStr) : DirStr;
begin
  while (Fn[byte(Fn[0])]<>'\') and (Fn[0]<>#0) do Dec(Byte(Fn[0]));
  DirOfFileName := Fn;
end;

function GetNameExt(const Fn : PathStr) : NameExtStr;
var
  Direct : DirStr;
  Name : NameStr;
  Ext  : ExtStr;
begin
  FSplit(Fn,Direct,Name,Ext);
  GetNameExt := Name+Ext;
end;

procedure CopyFTime(hs,hd : Word); assembler;
asm
  mov ax,5700h;
  mov bx,hs;
  int 21h
  jc @1;
  mov ax,5701h
  mov bx,hd
  int 21h
@1:
end;

procedure ClearKeyboardBuffer; assembler;
asm
@2:
  mov ah,01
  int 16h
  jz @1
  xor ah,ah
  int 16h
  jmp @2
@1:
end;

function FileExists(aF : PathStr) : Boolean;
var
  sr : SearchRec;
begin
  FindFirst(aF,Archive,Sr);
  FileExists := DosError=0;
end;


procedure DelFiles(It : PathStr;Attr : Word);
var
  Dir : DirStr;
  Sr : SearchRec;
  Fn : PathStr;
begin
  Dir := DirOfFileName(It);
  FindFirst(It,Attr,Sr);
  while DosError=0 do begin
    if (Sr.Name[1] <> '.') then begin
      Fn :=Dir+Sr.Name;
      if Sr.Attr = Directory then begin
        DelFiles(Fn+'\*.*',Attr);
        RmDir(Fn);
      end else DelFile(Fn);
    end;
    FindNext(Sr);
  end;
end;

function TmpFileName : PathStr;
var
  Sr : SearchRec;
  Stmp : ^String;
  FN : String[12];
begin
  repeat
    FN := StrHex(BiosTime^,SizeOf(BiosTime^));
    FN := FN + '.TMP';
    FN[1] := 'X';
    FindFirst(FN,Archive,Sr);
  until DosError<>0;
  TmpFileName := FExpand(Fn);
end;

procedure ErrMsg(const Msg : String); far;
var
  Msg_ : Array [0..255] of char;
const
  cerr = {$ifdef Windows}''{$else}'訡'{$endif};
begin
  if Msg = '' then Exit;
{$ifndef MSDOS}
  StrPCopy(Msg_,Msg);
  MessageBox(0,Msg_,cerr,MB_ICONSTOP+MB_OK);
{$else}
  Writeln(Msg);
{$endif}
end;


procedure IdleNop; far;
{$ifdef Windows}
var
  msg : tMsg;

begin
  while PeekMessage(msg,0,0,0,PM_REMOVE) do begin
    TranslateMessage(msg);
    DispatchMessage(msg);
  end;
{$else}
begin
{$endif}
end;

begin
  {$IFDEF Windows}
  BiosTime :=  Ptr($0040,$6C);
  {$Else}
  BiosTime := Ptr(Seg0040,$6C);
  {$Endif}
  ErrorMessage := ErrMsg;
  Idle := IdleNop;
end.
